common/xfs: refactor commands to select a particular xfs backing device
[xfstests-dev.git] / tests / xfs / 030
1 #! /bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3 # Copyright (c) 2000-2002 Silicon Graphics, Inc.  All Rights Reserved.
4 #
5 # FS QA Test No. 030
6 #
7 # exercise xfs_repair repairing broken filesystems
8 #
9 seqfull=$0
10 seq=`basename $0`
11 seqres=$RESULT_DIR/$seq
12 echo "QA output created by $seq"
13
14 here=`pwd`
15 tmp=/tmp/$$
16 status=1        # failure is the default!
17
18 _cleanup()
19 {
20         cd /
21         _scratch_unmount 2>/dev/null
22         rm -f $tmp.*
23 }
24
25 trap "_cleanup; exit \$status" 0 1 2 3 15
26
27 # get standard environment, filters and checks
28 . ./common/rc
29 . ./common/filter
30 . ./common/repair
31 . ./common/quota
32
33 # nuke the superblock, AGI, AGF, AGFL; then try repair the damage
34 #
35 _check_ag()
36 {
37         for structure in 'sb 0' 'agf 0' 'agi 0' 'agfl 0'
38         do
39                 echo "Corrupting $structure - setting bits to $1"
40                 _check_repair $1 "$structure" | uniq |
41                         sed -e '/^error following ag 0 unlinked list$/d' \
42                             -e '/^bad agbno AGBNO for finobt/d' \
43                             -e '/^bad agbno AGBNO for rmapbt/d' \
44                             -e '/^bad agbno AGBNO for refcntbt/d' \
45                             -e '/^agf has bad CRC/d' \
46                             -e '/^agi has bad CRC/d' \
47                             -e '/^bad inobt block count/d' \
48                             -e '/^bad finobt block count/d' \
49                             -e '/^Missing reverse-mapping record.*/d' \
50                             -e '/^bad levels LEVELS for [a-z]* root.*/d' \
51                             -e '/^unknown block state, ag AGNO, block.*/d'
52         done
53 }
54
55 # real QA test starts here
56 _supported_fs xfs
57
58 _require_scratch
59 _require_no_large_scratch_dev
60
61 DSIZE="-dsize=100m,agcount=6"
62
63 # first we need to ensure there are no bogus secondary
64 # superblocks between the primary and first secondary
65 # superblock (hanging around from earlier tests)...
66 #
67
68 _scratch_mkfs_xfs $DSIZE >/dev/null 2>&1
69 if [ $? -ne 0 ]         # probably don't have a big enough scratch
70 then
71         _notrun "SCRATCH_DEV too small, results would be non-deterministic"
72 else
73         _qmount_option noquota
74         _scratch_mount
75         $here/src/feature -U $SCRATCH_DEV && \
76                 _notrun "UQuota are enabled, test needs controlled sb recovery"
77         $here/src/feature -G $SCRATCH_DEV && \
78                 _notrun "GQuota are enabled, test needs controlled sb recovery"
79         $here/src/feature -P $SCRATCH_DEV && \
80                 _notrun "PQuota are enabled, test needs controlled sb recovery"
81         _scratch_unmount
82 fi
83 clear=""
84 eval `_scratch_xfs_db -r -c "sb 1" -c stack | perl -ne '
85         if (/byte offset (\d+), length (\d+)/) {
86                 print "clear=", $1 / 512, "\n"; exit
87         }'`
88 [ -z "$clear" ] && echo "Cannot calculate length to clear"
89 $here/src/devzero -v -1 -n "$clear" $SCRATCH_DEV >/dev/null
90
91 # now kick off the real repair test...
92 #
93 _scratch_mkfs_xfs $DSIZE | _filter_mkfs 2>$tmp.mkfs
94 . $tmp.mkfs
95 _check_ag 0
96 _check_ag -1
97
98 # success, all done
99 status=0
100 exit